# $Revision: 1.52.2.2 $, $Date: 2007/03/27 22:17:58 $
#
# Conditional build:
%bcond_without	dist_kernel	# allow non-distribution kernel
%bcond_without	kernel		# don't build kernel modules
%bcond_without	up		# don't build UP module
%bcond_without	smp		# don't build SMP module
%bcond_without	userspace	# don't build userspace module
%bcond_with	verbose		# verbose build (V=1)
%bcond_with	grsec_kernel	# build for kernel-grsecurity
#
%if %{with kernel} && %{with dist_kernel} && %{with grsec_kernel}
%define	alt_kernel	grsecurity
%endif
#
%define	iptables_ver	1.3.3
#
%define	_rel	5
Summary:	IPP2P - a netfilter extension to identify P2P filesharing traffic
Summary(pl):	IPP2P - rozszerzenie filtra pakietw identyfikujce ruch P2P
Name:		ipp2p
Version:	0.8.2
Release:	%{_rel}
Epoch:		1
License:	GPL
Group:		Base/Kernel
Source0:	http://www.ipp2p.org/downloads/%{name}-%{version}.tar.gz
# Source0-md5:	9dd745830f302d70d0b728013c1d6a0c
URL:		http://www.ipp2p.org/
%{?with_userspace:BuildRequires:	iptables-devel >= 1.3.3}
%if %{with kernel}
%if %{with dist_kernel}
BuildRequires:	kernel%{_alt_kernel}-module-build >= 3:2.6.7
%endif
%endif
BuildRequires:	rpmbuild(macros) >= 1.330
BuildRequires:	sed >= 4.0
Buildroot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%ifarch sparc
%undefine	with_smp
%endif

%description
IPP2P is a netfilter extension to identify P2P filesharing traffic.
The main goal for developing IPP2P was giving the adminstrator a
dynamic tool to filter the traffic in an intelligent way. So it
doesn't aim at prohibiting all P2P traffic but make it possible to
shape this traffic to a given rate. For this purpose IPP2P searchs the
payload of TCP packets for signaling patterns of P2P networks. As
these patterns are not being present in all P2P packets we had to use
some other netfilter extensions in order to get the whole IPP2P
package working as already described. IPP2P works together with
connection tracking and connection marking - in that way you can catch
the bigger part of all P2P packets and limit the bandwidth rate.

%description -l pl
IPP2P to rozszerzenie netfiltra suce do identyfikowania ruchu
zwizanego z dzieleniem plikw P2P. Gwnym celem tworzenia IPP2P jest
udostpnienie administratorowi dynamicznego narzdzia do filtrowania
ruchu w inteligentny sposb. Nie jest nim zablokowanie caego ruchu
P2P, ale umoliwienie ograniczenia tego ruchu do danej przepustowoci.
W tym celu IPP2P przeszukuje zawarto (payload) pakietw TCP pod
ktem wzorcw sygnalizujcych sieci P2P. Jeli tych wzorcw nie ma w
pakietach, musz by uyte inne rozszerzenia netfiltra, aby IPP2P
dziaao zgodnie z opisem. IPP2P wsppracuje ze ledzeniem oraz
znakowaniem pocze - w ten sposb mona wychwyci wiksz cz
pakietw P2P i ograniczy wykorzystanie cza przez nie.

%package -n kernel%{_alt_kernel}-net-ipp2p
Summary:	IPP2P - a netfilter extension to identify P2P filesharing traffic
Summary(pl):	IPP2P - rozszerzenie filtra pakietw identyfikujce ruch P2P
Release:	%{_rel}@%{_kernel_ver_str}
Group:		Base/Kernel
%{?with_dist_kernel:%requires_releq_kernel_up}
Requires(post,postun):	/sbin/depmod

%description -n kernel%{_alt_kernel}-net-ipp2p
IPP2P is a netfilter extension to identify P2P filesharing traffic.
The main goal for developing IPP2P was giving the adminstrator a
dynamic tool to filter the traffic in an intelligent way. So it
doesn't aim at prohibiting all P2P traffic but make it possible to
shape this traffic to a given rate. For this purpose IPP2P searchs the
payload of TCP packets for signaling patterns of P2P networks. As
these patterns are not being present in all P2P packets we had to use
some other netfilter extensions in order to get the whole IPP2P
package working as already described. IPP2P works together with
connection tracking and connection marking - in that way you can catch
the bigger part of all P2P packets and limit the bandwidth rate.

This package contains Linux kernel module.

%description -n kernel%{_alt_kernel}-net-ipp2p -l pl
IPP2P to rozszerzenie netfiltra suce do identyfikowania ruchu
zwizanego z dzieleniem plikw P2P. Gwnym celem tworzenia IPP2P jest
udostpnienie administratorowi dynamicznego narzdzia do filtrowania
ruchu w inteligentny sposb. Nie jest nim zablokowanie caego ruchu
P2P, ale umoliwienie ograniczenia tego ruchu do danej przepustowoci.
W tym celu IPP2P przeszukuje zawarto (payload) pakietw TCP pod
ktem wzorcw sygnalizujcych sieci P2P. Jeli tych wzorcw nie ma w
pakietach, musz by uyte inne rozszerzenia netfiltra, aby IPP2P
dziaao zgodnie z opisem. IPP2P wsppracuje ze ledzeniem oraz
znakowaniem pocze - w ten sposb mona wychwyci wiksz cz
pakietw P2P i ograniczy wykorzystanie cza przez nie.

Ten pakiet zawiera modu jdra Linuksa.

%package -n kernel%{_alt_kernel}-smp-net-ipp2p
Summary:	IPP2P - a netfilter extension to identify P2P filesharing traffic
Summary(pl):	IPP2P - rozszerzenie filtra pakietw identyfikujce ruch P2P
Release:	%{_rel}@%{_kernel_ver_str}
Group:		Base/Kernel
%{?with_dist_kernel:%requires_releq_kernel_smp}
Requires(post,postun):	/sbin/depmod

%description -n kernel%{_alt_kernel}-smp-net-ipp2p
IPP2P is a netfilter extension to identify P2P filesharing traffic.
The main goal for developing IPP2P was giving the adminstrator a
dynamic tool to filter the traffic in an intelligent way. So it
doesn't aim at prohibiting all P2P traffic but make it possible to
shape this traffic to a given rate. For this purpose IPP2P searchs the
payload of TCP packets for signaling patterns of P2P networks. As
these patterns are not being present in all P2P packets we had to use
some other netfilter extensions in order to get the whole IPP2P
package working as already described. IPP2P works together with
connection tracking and connection marking - in that way you can catch
the bigger part of all P2P packets and limit the bandwidth rate.

This package contains Linux SMP kernel module.

%description -n kernel%{_alt_kernel}-smp-net-ipp2p -l pl
IPP2P to rozszerzenie netfiltra suce do identyfikowania ruchu
zwizanego z dzieleniem plikw P2P. Gwnym celem tworzenia IPP2P jest
udostpnienie administratorowi dynamicznego narzdzia do filtrowania
ruchu w inteligentny sposb. Nie jest nim zablokowanie caego ruchu
P2P, ale umoliwienie ograniczenia tego ruchu do danej przepustowoci.
W tym celu IPP2P przeszukuje zawarto (payload) pakietw TCP pod
ktem wzorcw sygnalizujcych sieci P2P. Jeli tych wzorcw nie ma w
pakietach, musz by uyte inne rozszerzenia netfiltra, aby IPP2P
dziaao zgodnie z opisem. IPP2P wsppracuje ze ledzeniem oraz
znakowaniem pocze - w ten sposb mona wychwyci wiksz cz
pakietw P2P i ograniczy wykorzystanie cza przez nie.

Ten pakiet zawiera modu jdra Linuksa SMP.

%package -n iptables-ipp2p
Summary:	IPP2P - a netfilter extension to identify P2P filesharing traffic
Summary(pl):	IPP2P - rozszerzenie filtra pakietw identyfikujce ruch P2P
Release:	%{_rel}
Group:		Base/Kernel
Requires:	iptables

%description -n iptables-ipp2p
IPP2P is a netfilter extension to identify P2P filesharing traffic.
The main goal for developing IPP2P was giving the adminstrator a
dynamic tool to filter the traffic in an intelligent way. So it
doesn't aim at prohibiting all P2P traffic but make it possible to
shape this traffic to a given rate. For this purpose IPP2P searchs the
payload of TCP packets for signaling patterns of P2P networks. As
these patterns are not being present in all P2P packets we had to use
some other netfilter extensions in order to get the whole IPP2P
package working as already described. IPP2P works together with
connection tracking and connection marking - in that way you can catch
the bigger part of all P2P packets and limit the bandwidth rate.

This package contains iptables module needed to control IPP2P kernel
module.

%description -n iptables-ipp2p -l pl
IPP2P to rozszerzenie netfiltra suce do identyfikowania ruchu
zwizanego z dzieleniem plikw P2P. Gwnym celem tworzenia IPP2P jest
udostpnienie administratorowi dynamicznego narzdzia do filtrowania
ruchu w inteligentny sposb. Nie jest nim zablokowanie caego ruchu
P2P, ale umoliwienie ograniczenia tego ruchu do danej przepustowoci.
W tym celu IPP2P przeszukuje zawarto (payload) pakietw TCP pod
ktem wzorcw sygnalizujcych sieci P2P. Jeli tych wzorcw nie ma w
pakietach, musz by uyte inne rozszerzenia netfiltra, aby IPP2P
dziaao zgodnie z opisem. IPP2P wsppracuje ze ledzeniem oraz
znakowaniem pocze - w ten sposb mona wychwyci wiksz cz
pakietw P2P i ograniczy wykorzystanie cza przez nie.

Ten pakiet zawiera modu iptables potrzebny do sterowania moduem
jdra IPP2P.

%prep
%setup -q
sed -i "s:shell iptables:shell %{_sbindir}/iptables:" Makefile

%build
%if %{with userspace}
IPTABLES_VERSION="%{iptables_ver}"
%{__cc} %{rpmcflags} -DIPTABLES_VERSION=\"$IPTABLES_VERSION\" -fPIC -c libipt_ipp2p.c
#vim: "
ld %{rpmldflags} -shared -o libipt_ipp2p.so libipt_ipp2p.o
%endif

%if %{with kernel}
# kernel module(s)
%build_kernel_modules -m ipt_%{name}
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with userspace}
install -d $RPM_BUILD_ROOT%{_libdir}/iptables
install libipt_%{name}.so $RPM_BUILD_ROOT%{_libdir}/iptables
%endif

%if %{with kernel}
%install_kernel_modules -m ipt_%{name} -d kernel/net/ipv4/netfilter
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post -n kernel%{_alt_kernel}-net-ipp2p
%depmod %{_kernel_ver}

%postun -n kernel%{_alt_kernel}-net-ipp2p
%depmod %{_kernel_ver}

%post -n kernel%{_alt_kernel}-smp-net-ipp2p
%depmod %{_kernel_ver}smp

%postun -n kernel%{_alt_kernel}-smp-net-ipp2p
%depmod %{_kernel_ver}smp

%if %{with kernel}
%files -n kernel%{_alt_kernel}-net-ipp2p
%defattr(644,root,root,755)
%if %{with up} || %{without dist_kernel}
/lib/modules/%{_kernel_ver}/kernel/net/ipv4/netfilter/ipt_%{name}.ko*
%endif

%if %{with smp} && %{with dist_kernel}
%files -n kernel%{_alt_kernel}-smp-net-ipp2p
%defattr(644,root,root,755)
/lib/modules/%{_kernel_ver}smp/kernel/net/ipv4/netfilter/ipt_%{name}.ko*
%endif
%endif

%if %{with userspace}
%files -n iptables-ipp2p
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/iptables/*.so
%endif

%define	date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: ipp2p.spec,v $
Revision 1.52.2.2  2007/03/27 22:17:58  glen
- rel 5 (kernel 2.6.16.45)

Revision 1.52.2.1  2007/03/15 23:05:04  glen
- rel 4

Revision 1.52  2007/01/23 18:28:05  hawk
- release 3

Revision 1.51  2006/12/08 13:35:47  hawk
- reverted "use gcc for linking (we have -Wl, in ldflags)" from previous
  revision, breaks build
- workaround for builder automation to allow building against
  kernel-grsecurity (via bcond)
- release 2

Revision 1.50  2006/11/23 21:55:50  sparky
- use %build_kernel_modules and %install_kernel_modules
- use gcc for linking (we have -Wl, in ldflags)

Revision 1.49  2006/11/23 20:14:46  hawk
- update to 0.8.2

Revision 1.48  2006/11/23 19:28:10  adamg
- BuildRequires: rpmbuild(macros) >= 1.308 (alt_kernel support)

Revision 1.47  2006/11/23 19:04:12  hawk
- alt_kernel support
- release 5

Revision 1.46  2006/09/06 13:48:33  sparky
- mass atack: -j1 for make scripts

Revision 1.45  2006/07/02 15:44:24  hawk
- release 4

Revision 1.44  2006/04/12 11:34:09  glen
- tabs

Revision 1.43  2006/04/12 11:31:16  glen
- kernel epoch, fix %prep

Revision 1.42  2006/02/24 18:38:13  qboosh
- rel 3

Revision 1.41  2006/02/24 00:12:11  arekm
- sparc fix

Revision 1.40  2006/02/24 00:09:13  arekm
- new building way

Revision 1.39  2006/01/05 20:51:06  dzeus
- up to 0.8.1_rc1

Revision 1.38  2005/11/27 18:58:24  arekm
- rel 3

Revision 1.37  2005/11/13 02:15:15  sparky
- if there is no asm-powerpc link asm-ppc !
- spaces->tabs

Revision 1.36  2005/11/12 11:46:28  arekm
- rel 2

Revision 1.35  2005/10/21 20:22:23  dzeus
- up to final 0.8.0, cleanup

Revision 1.34  2005/09/17 03:16:21  wolvverine
- md5

Revision 1.33  2005/09/17 03:12:58  wolvverine
- up to 0.8.0_rc3

Revision 1.32  2005/09/15 18:25:05  sparky
- prepared for kernel >= 2.6.13: link Module.symvers

Revision 1.31  2005/05/22 10:22:41  averne
- rel 2

Revision 1.30  2005/05/15 17:32:16  qboosh
- use __cc

Revision 1.29  2005/05/14 11:40:02  kosmo
- fixed userspace build
- now iptables loads builded module

Revision 1.28  2005/03/23 12:10:09  andree
- updated to 0.7.4 (snap but builds on 2.6.11)
- updated url

Revision 1.27  2005/01/21 07:23:42  kosmo
- updated to 0.7.1

Revision 1.26  2004/12/30 01:42:01  pluto
- updated to 0.7 (thx Tomasz Kolaj).

Revision 1.25  2004/10/19 17:02:31  havner
- rel 5

Revision 1.24  2004/09/01 16:11:10  adamg
- kill pld.org.pl leftovers

Revision 1.23  2004/08/31 15:52:46  snurf
- typos / formatting / etc.

Revision 1.22  2004/08/08 17:55:17  havner
- rel 4

Revision 1.21  2004/07/29 13:35:45  havner
- rel 3 for rebuild

Revision 1.20  2004/07/29 13:06:10  averne
- rel2 for rebuild with proper iptables-devel

Revision 1.19  2004/07/22 19:15:07  qboosh
- Name changed to ipp2p, kernel-net-ipp2p.spec renamed to ipp2p.spec
- up module to subpackage, fixed smp depmods

Revision 1.18  2004/07/13 16:53:15  pluto
- BR(kernel-module-build) fixed.

Revision 1.17  2004/07/08 21:18:18  pluto
- updated to 0.6.
  (--gnu for better matching of Shareaza
   --edk new eMule and Kademlia patterns).

Revision 1.16  2004/07/03 21:05:17  pluto
- netfilter version = 1.2.11

Revision 1.15  2004/06/29 22:34:25  gotar
- s/filtru/filtra/

Revision 1.14  2004/05/30 18:07:42  pluto
- 2.6.7+ complaint.
- release 2.

Revision 1.13  2004/04/29 18:19:02  pluto
- netfilter version updated.

Revision 1.12  2004/04/08 11:35:36  pluto
- 2.6.5 fixes.

Revision 1.11  2004/03/16 09:51:59  qboosh
- removed empty post/postun for iptables module

Revision 1.10  2004/03/15 00:05:37  pluto
- updated to 0.5c.
  new option: --soul for SoulSeek (DROP only).
  extension: --kazaa also matches iMesh packets now.

  note that SoulSeek opens a new TCP connection for every download.
  We can not recognize this connection so marking does not work.
  But we can detect CONNECT and TRANSFER REQUEST packets so a DROP
  rule will make Soulseek stop working.

Revision 1.9  2004/03/14 18:40:53  pluto
- fixed INCPATH.

Revision 1.8  2004/03/14 17:34:37  pluto
- s/%{_kernel_ver_str}/%{_kernel_ver}/

Revision 1.7  2004/03/11 12:51:57  pluto
- fixed build with non-dist kernel.
- release 2.

Revision 1.6  2004/03/11 10:47:55  qboosh
- fixed build with dist_kernel once again

Revision 1.5  2004/03/10 18:58:58  pluto
- removed redudant symlinks {asm,autoconf.h}.
- multiconf build (up{,smp} xor nondist).

Revision 1.4  2004/03/10 16:19:25  qboosh
- fixed autoconf.h issue with distro kernel
- still waiting for pluto to fix both UP+SMP build

Revision 1.3  2004/03/04 19:08:55  qboosh
- merged fixes from HEAD and LINUX_2_6, cleanups, pl, kernel/userspace bconds

Revision 1.2  2004/03/03 22:39:46  ankry
- some typos, md5, fixed Group

Revision 1.1.2.8  2004/03/04 02:51:15  pluto
- drivers/net -> net/ipv4/netfilter

Revision 1.1.2.7  2004/03/04 01:51:05  pluto
- fixed cflags.

Revision 1.1.2.6  2004/03/03 22:37:57  pluto
- %desc, NFY...

Revision 1.1.2.5  2004/03/03 21:57:31  pluto
- fixed %build, %install, %files

Revision 1.1.2.4  2004/03/03 09:13:25  cieciwa
- fixed %build, %install, %files,
- %description and %summary not updated.

Revision 1.1.2.3  2004/03/03 08:32:26  cieciwa
- updated

Revision 1.1.2.2  2004/03/03 08:22:54  cieciwa
- updated

Revision 1.1.2.1  2004/03/03 08:17:31  cieciwa
- working on

Revision 1.1  2004/03/03 07:37:21  cieciwa
- initial
